﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using TestUltraWebGridDropDowns.DAL;

namespace TestUltraWebGridDropDowns.BLL
{
    public class WorkInProgress
    {
        public WorkInProgress(int id, string customer, string workType, string subWorkType)
        {
            Id = id;
            CustomerId = customer;
            WorkTypeId = workType;
            SubWorkTypeId = subWorkType;
        }
        public WorkInProgress()
        {
            Id = 0;
            CustomerId = String.Empty;
            WorkTypeId = String.Empty;
            SubWorkTypeId = String.Empty;
        }
        public int Id { get; set; }
        public string CustomerId { get; set; }
        public string WorkTypeId { get; set; }
        public string SubWorkTypeId { get; set; }

        public static List<WorkInProgress> GetAllWorkInProgress()
        {
            var da = new DataAccess();
            return da.GetAllWorkInProgress();
        }
        public static List<WorkInProgress> GetAllWorkInProgressForCustomer(int customerId)
        {
            var da = new DataAccess();
            return da.GetAllWorkInProgressForCustomer(customerId);
        }
        public static WorkInProgress GetWorkInProgress(int id)
        {
            var da = new DataAccess();
            return da.GetWorkInProgress(id);
        }
        public static WorkInProgress GetWorkInProgressFromReader(SqlDataReader reader)
        {
            return new WorkInProgress((int)reader["Id"],reader["Customer"].ToString(),reader["WorkType"].ToString(),
                reader["SubWorkType"].ToString());
        }
        public static List<WorkInProgress> GetWorkInProgressListFromReader(SqlDataReader reader)
        {
            var listToReturn = new List<WorkInProgress>();
            while (reader.Read())
            {
                listToReturn.Add(GetWorkInProgressFromReader(reader));
            }
            return listToReturn;
        }
    }
}