﻿using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using TestUltraWebGridDropDowns.DAL;

namespace TestUltraWebGridDropDowns.BLL
{
    public class WorkType
    {
        public WorkType(int workId, string workDescription)
        {
            WorkId = workId;
            WorkDescription = workDescription;
        }
        public WorkType()
        {
            WorkId = 0;
            WorkDescription = String.Empty;
        }

        public int WorkId { get; set; }
        public string WorkDescription { get; set; }

        public static List<WorkType> GetAllWorkTypes()
        {
            var dataAccess = new DataAccess();
            return dataAccess.GetWorkTypes();
        }
        public static WorkType GetWorkType(int id)
        {
            var da = new DataAccess();
            return da.GetWorkType(id);
        }
        public static WorkType GetWorkTypeFromReader(SqlDataReader reader)
        {
            return new WorkType((int)reader["Work_Id"],reader["Work_Description"].ToString());
        }
        public static List<WorkType> GetWorkTypeListFromReader(SqlDataReader reader)
        {
            var listToReturn = new List<WorkType>(); 
            while (reader.Read())
            {
                listToReturn.Add(GetWorkTypeFromReader(reader));
            }
            return listToReturn;
        }
    }
}