﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Web;
using System.Web.Configuration;
using TestUltraWebGridDropDowns.BLL;

namespace TestUltraWebGridDropDowns.DAL
{
    public class DataAccess
    {
        public DataAccess()
        {
            ConString = WebConfigurationManager.ConnectionStrings["DBConnection"].ToString();
        }

        public string ConString { get; set; }

        //Methods working for Customers
        public List<Customer> GetAllCustomers()
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM Customers", con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return Customer.GetCustomerListFromReader(reader);
            }
        }
        public Customer GetCustomer(int id)
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM Customers WHERE Id=" + id, con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return Customer.GetCustomerFromReader(reader);
            }
        }

        //Methods working for work types
        public List<WorkType> GetWorkTypes()
        {
            using (var con = new SqlConnection(ConString))
            {
                SqlCommand cmd = new SqlCommand("SELECT * FROM WorkTypes",con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                SqlDataReader reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkType.GetWorkTypeListFromReader(reader);
            }
        }
        public WorkType GetWorkType(int workTypeId)
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM WorkTypes WHERE Work_Id=" + workTypeId.ToString(), con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkType.GetWorkTypeFromReader(reader);
            }
        }

        //Methods working for work sub types
        public List<WorkSubType> GetWorkSubTypes(int workType)
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM WorkSubTypes WHERE WorkType_Id=" + workType, con) {CommandType = CommandType.Text};
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkSubType.GetSubWorkTypeListFromReader(reader);
            } 
        }
        public WorkSubType GetWorkSubType(int id)
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM WorkSubTypes WHERE SubWorkType_Id=" + id, con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkSubType.GetSubWorkTypeFromReader(reader);
            }
        }

        //Methods working with WorkInProgress
        public List<WorkInProgress> GetAllWorkInProgress()
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT WorkInProgress.Id,Customers.Name AS Customer,WorkTypes.Work_Description AS WorkType,WorkSubTypes.SubWork_Name AS SubWorkType" +
                                         " FROM WorkInProgress INNER JOIN Customers ON WorkInProgress.CustomerId=Customers.Id" +
                                         " INNER JOIN WorkTypes ON WorkInProgress.WorkTypeId=WorkTypes.Work_Id" +
                                         " INNER JOIN WorkSubtypes ON WorkInProgress.SubWorkTypeId=WorkSubtypes.SubWorkType_Id", con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkInProgress.GetWorkInProgressListFromReader(reader);
            }
        }
        public List<WorkInProgress> GetAllWorkInProgressForCustomer(int customerId)
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM WorkInProgress WHERE CustomerId=" + customerId, con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkInProgress.GetWorkInProgressListFromReader(reader);
            }
        }
        public WorkInProgress GetWorkInProgress(int id)
        {
            using (var con = new SqlConnection(ConString))
            {
                var cmd = new SqlCommand("SELECT * FROM WorkInProgress WHERE Id=" + id, con);
                cmd.CommandType = CommandType.Text;
                con.Open();
                var reader = cmd.ExecuteReader(CommandBehavior.CloseConnection);
                return WorkInProgress.GetWorkInProgressFromReader(reader);
            }
        }
    }
}