﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Web.Services;
using Infragistics.WebUI.UltraWebGrid;
using TestUltraWebGridDropDowns.BLL;

namespace TestUltraWebGridDropDowns
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            
            if (IsPostBack) return;

            //Create a ValueList and add some teams
            PopulateCustomerDropDown();
            PopulateTypeOfWorkDropDown();
            
            //The three columns must also be of type "DropDownList"
            //UltraWebGrid1.Columns[0].Type = ColumnType.DropDownList;
            //UltraWebGrid1.Columns[1].Type = ColumnType.DropDownList;
            //UltraWebGrid1.Columns[2].Type = ColumnType.DropDownList;

            //Add 6 rows just to give you room to play around
            UltraWebGrid1.Rows.Add();
            UltraWebGrid1.Rows.Add();
            UltraWebGrid1.Rows.Add();
            UltraWebGrid1.Rows.Add();
            UltraWebGrid1.Rows.Add();
            UltraWebGrid1.Rows.Add();

            //Make sure we can update the grid
            UltraWebGrid1.DisplayLayout.AllowUpdateDefault = AllowUpdate.Yes;

        }

        private void PopulateCustomerDropDown()
        {
            var customersList = Customer.GetAllCustomers();
            var customersTable = new DataTable();
            customersTable.Columns.Add("Id");
            customersTable.Columns.Add("Name");
            foreach (var customer in customersList)
            {
                var row = customersTable.NewRow();
                row["Id"] = customer.Id;
                row["Name"] = customer.Name;
                customersTable.Rows.Add(row);
            }
            var customersValueList = UltraWebGrid1.DisplayLayout.Bands[0].Columns[0].ValueList;
            customersValueList.DataSource = customersTable;
            customersValueList.ValueMember = "Id";
            customersValueList.DisplayMember = "Name";
            customersValueList.DataBind();
            UltraWebGrid1.DisplayLayout.Bands[0].Columns[0].Type = ColumnType.DropDownList;
            UltraWebGrid1.DisplayLayout.Bands[0].Columns[0].ValueList = customersValueList;
        }
        private void PopulateTypeOfWorkDropDown()
        {
            var workTypesList = WorkType.GetAllWorkTypes();
 	        var workTypesTable = new DataTable();
            workTypesTable.Columns.Add("Work_Id");
            workTypesTable.Columns.Add("Work_Description");
            foreach (var workType in workTypesList)
            {
                var row = workTypesTable.NewRow();
                row["Work_Id"] = workType.WorkId;
                row["Work_Description"] = workType.WorkDescription;
                workTypesTable.Rows.Add(row);
            }
            ValueList typeOfWorkValueList = UltraWebGrid1.DisplayLayout.Bands[0].Columns[1].ValueList;
            typeOfWorkValueList.DataSource = workTypesTable;
            typeOfWorkValueList.ValueMember = "Work_Id";
            typeOfWorkValueList.DisplayMember = "Work_Description";
            typeOfWorkValueList.DataBind();
            UltraWebGrid1.DisplayLayout.Bands[0].Columns[1].Type = ColumnType.DropDownList;
            UltraWebGrid1.DisplayLayout.Bands[0].Columns[1].ValueList = typeOfWorkValueList;
        }

        [WebMethod]
        public static List<WorkSubType> GetSubWorkTypes(int workType)
        {
            var listToReturn = WorkSubType.GetWorkSubTypes(workType);
            return listToReturn;
        }

        protected void BtnFetchDataClick(object sender, EventArgs e)
        {
            //Load data onto the grid
            UltraWebGrid1.DataSource = LoadGridData();
            UltraWebGrid1.DataBind();
        }

        private static List<WorkInProgress> LoadGridData()
        {
            return WorkInProgress.GetAllWorkInProgress();
        }
    }
}